/* Program 2.4 Cholesky Method
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
// CHOLESKY
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
class Cholesky {
public:
void calculateRoot(float A[5][50],float B[50], int NEQ) {
// THIS FUNCTION SOLVES A SYMMETRIC POSITIVE DEFINITIVE
// MATRIX BY A CHOLESKY DECOMPOSTION OF THE MATRIX
// EQUATION A*X=B.
// THE MATRIX IS DECOMPOSED INTO U*U=A.
// THEN THE EQUATION U*Y=B IS SOLVED FOR Y BY FORWARD
// SUBSTITUTION AND THE EQUATION U*X=Y SOLVED BY
// BACKWARD SUBSTITUTION.
float sq;
int NM1,i,j,IM1,IP1,N,N1;
int TIM1,m,TNM1,TI;
float C,D,VEC;
NM1=NEQ-1;
for(i=1;i<=NM1;i++) {
IM1=i-1;
IP1=i+1;
VEC=0.0;
TIM1=IM1;
for (m=1;m<=TIM1;m++)
VEC=VEC+A[1][m+1]*A[1][m+1];
A[i][i]=sqrt(A[i][i]-VEC);
D=1.0/A[i][i];
for(j=IP1;j<=NEQ;j++) {
VEC=0.0;
TIM1=IM1;
for (m=1;m<=TIM1;m++)
VEC=VEC+A[m][i]*A[m][j];
A[i][j]=D*(A[i][j]-VEC);
}
}
VEC=0.0;
TNM1=NM1;
for(m=1;m<=TNM1;m++)
VEC=VEC+A[m][NEQ]*A[m][NEQ];
A[NEQ][NEQ]=sqrt(A[NEQ][NEQ] - VEC );
for (i=1;i<=NEQ;i++) {
VEC=0.0;
TI=i-1;
for(m=1;m<=TI;m++)
VEC=VEC+A[m][i]*B[m];
B[i]=(B[i]-VEC)/A[i][i];
}
B[NEQ]=B[NEQ]/A[NEQ][NEQ];
for (i=1;i<=NM1;i++) {
N=NEQ-i;
N1=N+1;
C=0.0;
for (j=N1;j<=NEQ;j++)
C=C+A[N][j]*B[j];
B[N]=(B[N]-C)/A[N][N];
}
}
};
void main() {
float A[50][50],B[50],temp,temp1;
int i,j,NEQ;
Cholesky C;
clrscr();
cout<<"Enter Number of equations : ";
cin>>NEQ;
cout<<"Enter the Matrix : "<<endl;

for (i=1;i<=NEQ;i++)
for (j=1;j<=NEQ;j++)
cin>>A[i][j];
cout<<"Enter the RHS Values : "<<endl;
for (j=1;j<=NEQ;j++)
cin>>B[j];
cout<<"INPUT DATA"<<endl;
for (i=1;i<=NEQ;i++) {
for (j=1;j<=NEQ;j++)
cout<<A[i][j]<<"\t";
cout<<endl;
}
for (j=1;j<=NEQ;j++)
cout<<B[j]<<"\t";
cout<<endl;
C.calculateRoot(A,B,NEQ);
cout<<"SOLUTION VECTOR"<<endl;
for (j=1;j<=NEQ;j++)
cout<<B[j]<<"\t";
cout<<endl;
}
/* Input and output for Choleskey Method
Enter Number of equations : 3
Enter the Matrix :
9 6 3
6 5 1
3 1 4
Enter the RHS Values :
30 19 17
INPUT DATA
9 6 3
6 5 1
3 1 4
30 19 17
SOLUTION VECTOR
1 2 3
___________________________________________________________________________
*/