/* Program 3.1 LAGRANGIAN AND NEWTON DIVIDED DIFFERENCE METHOD
FOR INTERPOLATION by Dr. RM. Somasundaram & RM. Chandrasekaran
*/
// LAGRANGIAN AND NEWTON DIVIDED DIFFERENCE
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
double YOUT;
class Lagrange{
public:
void DIVDIF(double X[50],double Y[50],int N,double XINT) {
int k,i,j,NM1,NJ;
double DELY[50][50],TERM,NR,DR;
NM1=N-1;
for(k=1;k<=N;k++)
for (i=1;i<=N;i++)
DELY[k][i]=0.0;
for(i=1;i<=NM1;i++) {
NR=(Y[i+1]-Y[i]);
DR=(X[i+1]-X[i]);
DELY[i][1]=NR/DR;
}
for(j=2;j<=NM1;j++) {
NJ=N-j;
for (i=1;i<=NJ;i++) {
NR=(DELY[i+1][j-1] - DELY[i][j-1]);
DR=(X[i+j] - X[i]);
DELY[i][j] = NR / DR;
}
for (i=1;i<=NJ;i++) {
if (DELY[i][j]!=0.0)
break;
else
continue;
}
}
cout<<"X Y F(X1,X0)......."<<endl;
for(i=1;i<=N;i++) {
cout<<X[i]<<"\t"<<Y[i]<<"\t";
for(j=1;j<=N;j++)
cout<<DELY[i][j]<<" ";
cout<<endl;
}
for(j=1;j<=N;j++) {
if ((X[1]-XINT)>=0.0) {
if ((XINT-X[j])<=0.0)
goto L2;
else
return;
}
else
{
if ((XINT-X[j])>=0.0)
goto L2;
else
return;
}
L2:
YOUT=Y[j];
TERM=1.0;
for(k=1;k<=N;k++) {
TERM=TERM*(XINT-X[j+k-1]);
YOUT=YOUT+TERM*DELY[j][k];
}
cout<<"Y VALUE FOR (X="<<XINT<<") IS EQUAL TO "<<YOUT;
cout<<" FOR X0 = "<<X[j]<<endl;
}
}
void LAGINT(double X[50],double Y[50],int N,double XINT) {
int i,j;
float TERM;
YOUT=0.0;
for (i=1;i<=N;i++)
{
TERM = Y[i];
for (j=1;j<=N;j++) {
if (i==j)
continue;
TERM*=(XINT-X[j])/(X[i]-X[j]);
}
YOUT = YOUT +TERM;
}
}
};
void main() {
int N,i;
char CH;
double X[50],Y[50],XINT,t1,t2;
Lagrange l;
clrscr();
cout<<"NUMBER OF POINTS IN THE TABLE : ";
cin>>N;
cout<<"X and Y Values : "<<endl;
for(i=1;i<=N;i++) {
cin>>X[i]>>Y[i];
}
cout<<"Enter the X value to interpolate : ";
cin>>XINT;
cout<<endl<<"INTERPOLATION METHODS "<<endl;
cout<<" 1. NEWTON DIVIDED DIFFERENCE (N)"<<endl;
cout<<" 2. LAGRANGIAN INTERPOLATION (L)"<<endl;
cout<<" ENTER L OR N : ";
cin>>CH;
switch(CH) {
case 'N' : l.DIVDIF(X,Y,N,XINT);
break;
case 'L' : l.LAGINT(X,Y,N,XINT);
break;
default : cout<<"Error";
exit(0);
}
cout<<"SOLUTION"<<endl;
cout<<"Y VALUE FOR (X="<<XINT<<") = "<<YOUT;
}
/*
_________________________________________________________________________________
 Input & Output for Lagrange Method
NUMBER OF POINTS IN THE TABLE : 4
X and Y Values :
-1 5
0 2
2 0
3 1
Enter the X value to interpolate : 1
INTERPOLATION METHODS
1. NEWTON DIVIDED DIFFERENCE ('N')
2. LAGRANGIAN INTERPOLATION ('L')
ENTER 'L' OR 'N' : L
SOLUTION
Y VALUE FOR (X=1) = 0.333333
_________________________________________________________________________________
Input & Output for Newton Divided Difference Method
NUMBER OF POINTS IN THE TABLE : 4
X and Y Values :
-1 5
2 0
0 2
3 1
Appendix 197
Enter the X value to interpolate : 1
INTERPOLATION METHODS
1. NEWTON DIVIDED DIFFERENCE ('N')
2. LAGRANGIAN INTERPOLATION ('L')
ENTER 'L' OR 'N' : N
X Y F(X1,X0).......
-1 5 -1.666667 0.666667 0 0
2 0 -1 0.666667 0 0
0 2 -0.333333 0 0 0
3 1 0 0 0 0
Y VALUE FOR (X=1) IS EQUAL TO 0.333333 FOR X0 = -1
SOLUTION
Y VALUE FOR (X=1) = 0.333333
*/