/* Program 7.4 GAUSSIAN QUADRATURE Method for evaluating an integral
by Dr. RM. Somasundaram & Rm. Chandrasekaran */
#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
#include <stdlib.h>
#include <math.h>
double A[10],W[10];
class GauQuad{
public:
void doCalculate(int NGAUS) {
int i,II,NGM1,NGUAS,ISUM,I2,NGAUS2,NPOINT,NPI;
static double XGAUS[]=
{ 0,0.0,0.57735,0.77459,0.0,0.86113,0.33998,0.90617,
0.53846,0,0.93246,0.66120,0.23861,0.9491,0.74153,
0.40584,0,0.96028,0.79666,0.52553,0.18343,0.96816,
0.83603,0.61337,0.32425,0,0.97390,0.86506,0.67940,
0.43339,0.14887};
static double WGAUS[]=
{ 0,2,1,0.55555,0.88888,0.34785,0.65214,0.23692,
0.47862,0.56888,0.17132,0.36076,0.46791,0.12948,
0.27970,0.38183,0.41795,0.10122,0.22238,0.31370,
0.36268,0.08127,0.18064,0.260161,0.31234,0.33023,
0.06667,0.14945,0.21908,0.26926,0.29552};
NGM1=NGAUS-1;
ISUM=0;
for (i=1;i<=NGM1;i++) {
I2=i/2;
ISUM+=I2;
if ((i%2)!=0)
ISUM+=1;
}
NGAUS2=NGAUS/2;
NPOINT=NGAUS2;
if ((NGAUS%2)!=0)
NPOINT++;
for (i=1;i<=NPOINT;i++) {
II = ISUM+i;
A[i]=-XGAUS[II];
W[i]=WGAUS[II];
}
NPI=NPOINT+1;
for(i=NPI;i<=NGAUS;i++) {
II=NGAUS -i+1;
A[i]=-A[II];
W[i]=W[II];
}
}
double F(double Y) {
float F,cin,cout;
/// Book PBM
// cin=10.0+(20.0*Y)-(0.3*Y*Y)+(0.04*Y*Y*Y);
// cout=-0.005*pow(Y,4)+0.0006*pow(Y,5);
//cin= 1.0/(1.0+Y);
cin = exp(-Y*Y);
cout=-0.00;
F=cin+cout;
return F;
}
double FF(double X,double Y) {
return (exp(X)*sin(Y));
}
};
void main() {
int NDIM,NGAUS,i,j,count;
double XU,XL,YU,YL,SUM,X,Y,T,VALUE,FUN;
clrscr();
GauQuad gq;
cout<<"Enter the Dimension : ";
cin>>NDIM;
cout<<"X UPPER = ";
cin>>XU;
cout<<"X LOWER = ";
cin>>XL;
cout<<"Y UPPER = ";
cin>>YU;
cout<<"Y LOWER = ";
cin>>YL;
count=1;
while(count<7) {
cout<<"Enter The Value of N : ";
cin>>NGAUS;
gq.doCalculate(NGAUS);
SUM=0;
for(i=1;i<=NGAUS;i++) {
X=0.5*((XU+XL)+ (XU-XL) * A[i]);
T=1.0;
if(NDIM==2)
T=W[i];
for(j=1;j<=NGAUS;j++) {
Y=0.5*( (YU+YL) + (YU-YL)*A[j]);
if(NDIM==1)
FUN=gq.F(Y);
else
FUN=gq.FF(X,Y);
SUM+=T*W[j]*FUN;
}
if(NDIM==1)
goto L2;
}
L2:
VALUE=(YU-YL)*SUM/2.0;
if(NDIM!=1)
VALUE*=(XU-XL)/2.0;
cout<<"THE VALUE OF THE INTEGRAL FOR "<<NGAUS;
cout<<" GAUSS POINTS = "<<VALUE<<endl;
count++;
}
}
/* Input & output for Gaussian Quadrature  1 Dimension
Enter the Dimension : 1
X UPPER = 0
X LOWER = 0
Y UPPER = 1
Y LOWER = 0
Enter The Value of N : 1
THE VALUE OF THE INTEGRAL FOR 1 GAUSS POINTS = 0.666667
Enter The Value of N : 2
THE VALUE OF THE INTEGRAL FOR 2 GAUSS POINTS = 0.692308
Enter The Value of N : 3
THE VALUE OF THE INTEGRAL FOR 3 GAUSS POINTS = 0.693114
Enter The Value of N : 4
THE VALUE OF THE INTEGRAL FOR 4 GAUSS POINTS = 0.693139
Enter The Value of N : 5
THE VALUE OF THE INTEGRAL FOR 5 GAUSS POINTS = 0.693132
Enter The Value of N : 6
THE VALUE OF THE INTEGRAL FOR 6 GAUSS POINTS = 0.693139
*/